dofile( "data/scripts/lib/utilities.lua" )
dofile( "data/scripts/perks/perk_list.lua" )
dofile( "data/scripts/perks/perk.lua" )

function OnModPreInit()
	print("Mars Mod - OnModPreInit()")
end

function OnModInit()
	print("Mars Mod - OnModInit()")
end

function OnModPostInit()
	print("Mars Mod - OnModPostInit()")
end

function OnPlayerSpawned(player_entity)
	print("Mars Mod - OnPlayerSpawned() - Begin")
	
	local init_check_flag = "mars_mod_flag"
	if GameHasFlagRun(init_check_flag) then return end
	GameAddFlagRun(init_check_flag)
	
	print("Mars Mod - OnPlayerSpawned() - Loading Script ...")
	EntityAddComponent(player_entity, "LuaComponent", {script_source_file="mods/marsmod/files/marsmod.lua", execute_on_added="1", remove_after_executed="0", execute_every_n_frame="1"})
	print("Mars Mod - OnPlayerSpawned() - Script Loaded")
	
	local x, y = EntityGetTransform(player_entity)
	perk_spawn(x, y, "EDIT_WANDS_EVERYWHERE")
	
	print("Mars Mod - OnPlayerSpawned() - Modding Player ...")
	local components = EntityGetComponent(player_entity, "DamageModelComponent")
	if (components ~= nil) then
		for i, component in pairs(components) do
			if (component ~= nil) then
				mod_damage(component, "damage_multipliers", 0.75)
				
				ComponentSetValue(component, "max_hp", 5)
				ComponentSetValue(component, "hp", 5)
			end
		end
	end
	print("Mars Mod - OnPlayerSpawned() - Player Modded")
	
	print("Mars Mod - OnPlayerSpawned() - End")
end

function mod_damage(c, o, m)
	local members = ComponentObjectGetMembers(c, o)
	if not members then return end
	for k, v in pairs(members) do
		ComponentObjectSetValue(c, o, k, ComponentObjectGetValue(c, o, k) * m)
		print("Mars - '" .. tostring(k) .. "' damage taken set to " .. tostring(ComponentObjectGetValue(c, o, k)))
	end
end
